#!/usr/bin/python3
# -*- coding:utf-8 -*-

import os
import gi
import notify2

gi.require_version("Gtk", "3.0")

from gi.repository import Gtk as gtk
from gi.repository import Gdk
from gi.repository import AppIndicator3 as appindicator

class cga_control_webcam:
    def __init__(self):
      indicador = appindicator.Indicator.new("cga-control-webcam", os.path.abspath("/usr/share/cga-control-webcam/icons/cam.png"), appindicator.IndicatorCategory.SYSTEM_SERVICES)
      indicador.set_status(appindicator.IndicatorStatus.ACTIVE)

      self.menu = gtk.Menu()
      menu_activar = gtk.MenuItem('Activar WebCam')
      self.menu.append(menu_activar)
      menu_desactivar = gtk.MenuItem('Desactivar WebCam')
      self.menu.append(menu_desactivar)
      menu_salir = gtk.MenuItem('Salir')
      self.menu.append(menu_salir)

      menu_activar.connect("activate", self.activar)
      menu_desactivar.connect("activate", self.desactivar)
      menu_salir.connect("activate", gtk.main_quit)

      menu_salir.show()
      menu_activar.show()
      menu_desactivar.show()

      indicador.set_menu(self.menu)
      gtk.main()

    def activar(self, action):
      os.system("sudo /usr/share/cga-control-webcam/control.sh activar")
      resultado_activar = os.system("lsmod | grep uvcvideo 2>/dev/null")
      notify2.init("Info")
      notice = notify2.Notification("Dispositivos de grabación ACTIVADOS", "Cierre las aplicaciones en uso y vuelva abrirlas para efectuar los cambios", "educaandos_logo")
      notice.show()

    def desactivar(self,action):
      os.system("sudo /usr/share/cga-control-webcam/control.sh desactivar")
      resultado = os.system("lsmod | grep uvcvideo 2>/dev/null")
      if (resultado):
        notify2.init("Info")
        notice = notify2.Notification("Dispositivos de grabación DEACTIVADOS", "Todos los dispositivos se han deshabilitado con éxito", "educaandos_logo")
        notice.show()
      else:
        notify2.init("Info")
        notice = notify2.Notification("No se pudo completar la operación", "Antes debe cerrar la aplicación en uso", "educaandos_logo")
        notice.show()


if __name__ == "__main__":
  app = cga_control_webcam()
